#ifdef GL_ES
precision lowp float;
#endif

varying vec2 v_texCoord;
uniform sampler2D u_texture;
uniform vec3 u_keyColor;
uniform vec3 u_glowColor;
uniform vec2 u_texel;


bool isKeyColor ( int x , int y ) {
    vec3 texcolor = texture2D( u_texture, vec2(
        v_texCoord.s + u_texel.s * float(x),
        v_texCoord.t + u_texel.t * float(y) ) ).rgb;
    vec3 diff = texcolor - u_keyColor;
    return length( diff ) < 0.5;
}

float glowAmount () {
    float total = 0.0;
    float weight = 1.0 / 9.0;
    int i, j;
    for ( i = -5 ; i <= 5 ; i = i + 1 ) {
        for ( j = -5 ; j <= 5 ; j = j + 1 ) {
            if ( isKeyColor(i,j) ) total += weight;
        }
    }
    return total;
}

void main () {
    vec4 texcolor = texture2D(u_texture, v_texCoord);
    vec4 glow = vec4(u_glowColor,1.0) * glowAmount();
    gl_FragColor = clamp(vec4(0.0), vec4(1.0), texcolor + glow);
}  