#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform sampler2D u_texture;
uniform vec3 u_skinColor;
uniform vec3 u_lipsColor;
uniform vec3 u_eyesColor;

void main()
{

    vec4 color = texture2D(u_texture, v_texCoord);
    if (color.r == 0.0 && color.g == 0.0 && color.b > 0.0) {
        // B: eyes, switch to u_eyesColor
        color = vec4(u_eyesColor * color.b, color.a);
    } else if (color.r == 0.0 && color.g > 0.0 && color.b == 0.0) {
        // G: collar, switch to #7F7F7F
        color = vec4(vec3(0.5 * color.g), color.a);
    } else if (color.r > 0.0 && color.g == 0.0 && color.b == 0.0) {
        // R: lips, switch to lips color
        color = vec4(u_lipsColor * color.r, color.a);
    } else {
        // switch rest to skin color
        color = vec4(u_skinColor*color.r, color.a);
    }
    gl_FragColor = v_fragmentColor * color;
}
