#ifdef GL_ES
precision highp float;
#endif

varying vec2 v_texCoord;
uniform sampler2D u_texture;
uniform float u_time;

varying float ypos;
float rand(float n){return fract(sin(n) * 43758.5453123);}
void main() {
    float scanlines = clamp(sin(ypos*400.0) * 10000.0, 0.75, 1.0);
    float grain = clamp(rand(u_time * v_texCoord.x * v_texCoord.y), 0.75, 1.0);
    // alpha was messing up animations, so it's affecting colors instead for now
    float alpha = 0.8 + sin(u_time*5.0) * 0.1;
    float banding = (sin(ypos*20.0 + u_time*2.0)+0.5)/10.0;
    vec4 bluetint  = vec4((0.3 - banding) * scanlines, (0.5 - banding) * scanlines, (0.8 - banding) * scanlines, 0.0);
    gl_FragColor = texture2D(u_texture, v_texCoord) * vec4(grain*alpha,grain*alpha,grain*alpha,1.0) + bluetint;
}