#ifdef GL_ES
    precision highp float;
#endif
varying vec4 v_fragmentColor;
uniform sampler2D u_texture;
uniform float u_time;

varying vec2 v_pos;
void main() {
    float time = u_time / 500.0; // speed
    vec2 uv = v_pos * 0.5; // uv * scale
    vec3 t;
    const float m = 3.0;
    // interference pattern based on soft noise texture
    vec3 t1 = texture2D(u_texture, uv + time*(-1.75)).rgb * m;
    vec3 t2 = texture2D(u_texture, uv + time*(-0.93)).rgb * m;
    vec3 t3 = texture2D(u_texture, uv + time*( 1.55)).rgb * m;
    
    float c = fract(t1.r + t1.g + t1.b + t2.r + t2.g + t2.b + t3.r + t3.g + t3.b);
    // soft ramp
    if (c < 0.3333) {
        c = pow(abs(sin(3.141592*(c+0.5))), 10.0);
    } else {
        c = 1.5*c - 0.5;
    }

    // blue tint & vertex alpha
    gl_FragColor = vec4(0.25+c*0.05, 0.5+c*0.1, 0.5+c*0.5, 0.5 * v_fragmentColor.a);
}