#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform sampler2D u_texture;
uniform float u_outlineWidth;
uniform vec4 u_outlineColor;
uniform vec4 u_fillColor;

float getAlpha(vec2 offset)
{
    vec2 modifiedCoord = v_texCoord + offset;
    
    if (modifiedCoord.x < 0.0
        || modifiedCoord.x > 1.0
        || modifiedCoord.y < 0.0
        || modifiedCoord.y > 1.0) {
        return 0.0;
    }
    return texture2D(u_texture, modifiedCoord).a;
}

void main()
{
    if (getAlpha(vec2(0,0)) != 0.0) {
        if (getAlpha(vec2(-u_outlineWidth, 0)) == 0.0 || getAlpha(vec2(u_outlineWidth, 0)) == 0.0 || getAlpha(vec2(0, u_outlineWidth)) == 0.0 || getAlpha(vec2(0, -u_outlineWidth)) == 0.0) {
            gl_FragColor = u_outlineColor;
        } else {
            gl_FragColor = u_fillColor;
        }
    } else {
        gl_FragColor = vec4(0,0,0,0);
    }
}
