#ifdef GL_ES
    precision highp float;
    #endif

    varying vec4 v_fragmentColor;
    varying vec2 v_texCoord;
    varying vec2 blurCoordinates[5];
    uniform sampler2D u_texture;
    uniform float u_time;

    float pi = 3.1415926;
    float pi2 = 2.0 * 3.1415926;
    vec4 rnd(vec2 pos)
    {
        return texture2D(u_texture, pos);
    }
    float wave(vec2 uv)
    {
        float m = 0.0;
        float sum = 0.0;
        const float n = 4.0;
        for(float y = 1.0; y <= n; y++)
        {
            for(float x = 1.0; x <= n; x++)
            {
                vec4 r = rnd(vec2(x, y) / n);
                r.z = 2.0 * r.z - 1.0;
                float a = sin(pi2 * (x * uv.x + r.x + 0.5 * u_time * r.z));
                float b = sin(pi2 * (y * uv.y + r.y + 0.5 * u_time * r.z));
                sum += a * b / (x * y);
                m += 1.0 / (x * y);
            }
        }
        return sum / m;
    }

    void main()
    {
        // vec3 nrm = vec3(vec2(wave(v_texCoord)*5.0),1.0);
        // vec3 r = refract(vec3(0.0, 0.0, 1.0), nrm, 1.0);
        // gl_FragColor = texture2D(u_texture, v_texCoord.xy + 0.01 * r.xy);

        // float d = 0.001;
        // float f = 0.5;
        // vec4 color = texture2D(u_texture, v_texCoord);
        // color += texture2D(u_texture, v_texCoord + vec2(-d,0.0)) / f;
        // color += texture2D(u_texture, v_texCoord + vec2(+d,0.0)) / f;
        // color += texture2D(u_texture, v_texCoord + vec2(0.0,-d)) / f;
        // color += texture2D(u_texture, v_texCoord + vec2(0.0,+d)) / f;
        // gl_FragColor = color / (1.0+(4.0/f));
//
    // color shift
//        gl_FragColor.r = texture2D(u_texture, v_texCoord + vec2(0.0,0.0)).r;
//        gl_FragColor.g = texture2D(u_texture, v_texCoord + vec2(0.01,0.0)).g;
//        gl_FragColor.b = texture2D(u_texture, v_texCoord + vec2(0.02,0.0)).b;
//        gl_FragColor.a = 1.0;
    //
    // B&W
       // vec4 color = (v_fragmentColor * texture2D(u_texture, v_texCoord));
       // float c = (color.r + color.g + color.b) / 3.0;
       // gl_FragColor = vec4(c,c,c,1.0);
        gl_FragColor = texture2D(u_texture, v_texCoord.xy);
//
//    vec4 sum = vec4(0.0);
//    sum += texture2D(u_texture, blurCoordinates[0]) * 0.204164;
//    sum += texture2D(u_texture, blurCoordinates[1]) * 0.304005;
//    sum += texture2D(u_texture, blurCoordinates[2]) * 0.304005;
//    sum += texture2D(u_texture, blurCoordinates[3]) * 0.093913;
//    sum += texture2D(u_texture, blurCoordinates[4]) * 0.093913;
//    gl_FragColor = sum;
    }