#ifdef GL_ES
precision lowp float;
#endif

varying vec2 v_texCoord;
uniform sampler2D u_texture;
uniform vec3 u_LightDirection;
uniform float u_alpha;
uniform vec3 u_edgeGlowColor;

varying vec3 v_normal;

void main() {
	vec3 normal = normalize(v_normal);
    float lightIntensity = clamp(dot(normal, u_LightDirection)*5.0, 0.2, 1.0);
    vec4 lightColor = vec4(vec3(lightIntensity), u_alpha);
    float edgeGlowIntensity = clamp(1.0 - normal.z*3.0, 0.0, 1.0) * 0.6;
    vec4 edgeGlow = vec4(u_edgeGlowColor*edgeGlowIntensity, 0.0);
    gl_FragColor = texture2D(u_texture, v_texCoord) * lightColor + edgeGlow;
}
