attribute vec4 a_position;
attribute vec3 a_normal;
attribute vec2 a_texCoord;

uniform mat4 u_MVMatrix;
uniform mat4 u_MVPMatrix;
uniform vec3 u_LightDirection;

#ifdef GL_ES
precision lowp float;
varying mediump vec2 v_texCoord;
#else
varying vec2 v_texCoord;
#endif
varying vec3 v_normal;

void main() {
    gl_Position = u_MVPMatrix * a_position;
    v_texCoord = vec2(a_texCoord.s, 1.0 - a_texCoord.t);
    v_normal = mat3(u_MVMatrix) * a_normal;
}
