#ifdef GL_ES
precision lowp float;
precision lowp int;
#else
precision highp float;
precision highp int;
#endif
uniform sampler2D u_texture;
uniform float u_percentage; //normalized
uniform int u_direction;
uniform vec4 u_color;
varying vec2 v_texCoord;
varying mediump vec2 v_position;
bool shouldDraw() {
    return (u_direction == 0 && v_position.x <= u_percentage)       ||
           (u_direction == 1 && v_position.x >= 1.0 - u_percentage) ||
           (u_direction == 2 && v_position.y <= u_percentage)       ||
           (u_direction == 3 && v_position.y >= 1.0 - u_percentage);
}
void main() {
    if (shouldDraw() == false) {
        gl_FragColor = vec4(0);
    } else {
        gl_FragColor = u_color * texture2D(u_texture, v_texCoord);
    }
}
