attribute vec4 a_position;
attribute vec2 a_texCoord;
attribute vec4 a_color;

uniform mat4 u_MVPMatrix;
uniform float u_time;

#ifdef GL_ES
varying lowp vec4 v_fragmentColor;
varying mediump vec2 v_texCoord;
#else
varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
#endif

void main()
{
    gl_Position = u_MVPMatrix * a_position;
    if (vec4(1.0) == a_color) {
        v_fragmentColor = a_color;
    } else {
        float dt = fract(u_time);
        float flr = floor(u_time);
        float pingOrPong = mod(flr, 2.0);
        dt = abs(pingOrPong - dt);
        vec4 color = mix( a_color, vec4(3.0)*a_color,dt);
        v_fragmentColor = color;
        v_fragmentColor.a = a_color.a;
    }
    v_texCoord = a_texCoord;
}
