attribute vec4 a_position;
attribute vec2 a_texCoord;
attribute vec4 a_color;

uniform mat4 u_MVPMatrix;
uniform vec3 u_recolor;

#ifdef GL_ES
  varying lowp vec4 v_fragmentColor;
  varying mediump vec2 v_texCoord;
#else
  varying vec4 v_fragmentColor;
  varying vec2 v_texCoord;
#endif

void main()
{
  gl_Position = u_MVPMatrix * a_position;
  float index = a_color.r;
  vec4 indexedColor = vec4(1.0);
  if(index > 0.0)
    indexedColor = vec4(u_recolor, 1.0);
  v_fragmentColor = indexedColor * vec4(a_color.g);
  v_texCoord = a_texCoord;
}