#ifdef GL_ES
precision lowp float;
#endif

varying vec2 v_texCoord;
uniform sampler2D u_texture;
uniform vec3 u_LightDirection;
uniform float u_alpha;
varying vec3 v_normal;

void main()
{
    vec3 normal = normalize(v_normal);
    float lightIntensity = clamp(dot(normal, u_LightDirection), 0.4, 1.0);
    // toon style highlight
    if (lightIntensity > 0.8) {
        lightIntensity += 0.2;
    }
    vec4 light = vec4(vec3(lightIntensity),1.0);

    // ship glow, turned off for now
    // float edgeGlowIntensity = clamp(1.0 - pow(dot(normal, vec3(0.0,0.0,3.0)), 1.0), 0.0, 1.0) * 0.4;
    // vec4 edgeGlow = vec4(vec3(edgeGlowIntensity),0.0);
    // gl_FragColor = (texture2D(u_texture, v_texCoord) * light + edgeGlow) * u_alpha;
    gl_FragColor = (texture2D(u_texture, v_texCoord) * light) * u_alpha;
}
