#ifdef GL_ES
precision lowp float;
#endif

varying vec2 v_texCoord;
uniform sampler2D u_texture;
uniform float u_alpha;
varying vec3 v_normal;
varying vec4 v_position;
uniform mat4 u_MMatrix;
uniform vec3 u_LightDirection;

void main()
{
	vec3 normal = normalize(v_normal);
    float lightIntensity = clamp(dot(normal, u_LightDirection), 0.4, 1.0);
    // toon style highlight
    if (lightIntensity > 0.8) {
        lightIntensity += 0.2;
    }
    vec4 light = vec4(vec3(lightIntensity),1.0);

    float mask = clamp(mix(0.0, 1.0, ((u_MMatrix * v_position)[2] -0.4) * 10.0), 0.1, 1.0);
    gl_FragColor = (texture2D(u_texture, v_texCoord) * light) * vec4(mask);
}
