#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform sampler2D u_texture;
uniform float u_pos;
uniform float u_scale;
uniform float u_alpha;
uniform float u_fade_end;
uniform float u_fade_start;
uniform float u_scrim_color;

void main()
{
    float f = (gl_FragCoord.y - u_pos) / u_scale;
    float a = min(u_alpha + max(((u_fade_end - f) * (1.0-u_alpha))/(u_fade_end - u_fade_start), 0.0), 1.0);
    gl_FragColor = v_fragmentColor * texture2D(u_texture, v_texCoord) * vec4(vec3(u_scrim_color),a);
}
