#ifdef GL_ES
precision highp float;
#endif

varying vec2 v_texCoord;
uniform sampler2D u_texture;
uniform float u_time;

const float speed     = 0.05;
const float frequency = 10.0;

vec2 shift( vec2 p ) {
    float d = u_time*speed;
    vec2 f = frequency * (p + d);
    vec2 q = cos( vec2(cos(f.x-f.y)*cos(f.y),
                       sin(f.x+f.y)*sin(f.y) ) );
    return q;
}


void main() {
    vec2 uv = v_texCoord;

    vec2 r = uv;
    vec2 p = shift( r );
    vec2 q = shift(r + 1.0);
    float amplitude = 0.01;
    vec2 s = r + amplitude * (p - q);
    gl_FragColor = texture2D(u_texture,s);


}
