#ifdef GL_ES
precision highp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
varying vec2 blurCoordinates[5];
uniform sampler2D u_texture;
uniform float u_time;

float pi = 3.1415926;
float pi2 = 2.0 * 3.1415926;

float rand(float n){return fract(sin(n) * 43758.5453123);}

vec4 rnd(vec2 pos)
{
    return texture2D(u_texture, pos);
}
float wave(vec2 uv)
{
    float m = 0.0;
    float sum = 0.0;
    const float n = 4.0;
    for(float y = 1.0; y <= n; y++)
    {
        for(float x = 1.0; x <= n; x++)
        {
            vec4 r = rnd(vec2(x, y) / n);
            r.z = 2.0 * r.z - 1.0;
            float a = sin(pi2 * (x * uv.x + r.x + 0.5 * u_time * r.z));
            float b = sin(pi2 * (y * uv.y + r.y + 0.5 * u_time * r.z));
            sum += a * b / (x * y);
            m += 1.0 / (x * y);
        }
    }
    return sum / m;
}

void main()
{
    vec3 nrm = vec3(vec2(wave(v_texCoord)*5.0),1.0);
    vec3 r = refract(vec3(0.0, 0.0, 1.0), nrm, 1.0);
    gl_FragColor = texture2D(u_texture, v_texCoord.xy + 0.01 * r.xy);
}